package com.pcloud.common.dto;

import java.io.Serializable;
import java.math.BigDecimal;

import lombok.AllArgsConstructor;
import lombok.Builder;
import lombok.Data;
import lombok.NoArgsConstructor;

@Data
@Builder
@NoArgsConstructor
@AllArgsConstructor
public class ListBookResourceDto implements Serializable {

    private static final long serialVersionUID = -1577379350983082161L;
    private String bookAdviserChannelId;

    private Long sceneId;

    private String qrcodeType;

    private Long bookId;

    private Long channelId;

    private Long adviserId;

    /**
     * 资源、服务
     */
    private String resourceServe;

    /**
     * app,product,resource,member_activity
     */
    private String typeCode;

    /**
     * 资源名称
     */
    private String serveName;


    private Long serveId;

    /**
     * 资源类型
     */
    private String serveType;

    private String serveTypeName;

    /**
     * 专业标签
     */
    private Long proLabelId;

    /**
     * 深度标签
     */
    private Long depLabelId;

    /**
     * 目的标签
     */
    private Long purLabelId;

    /**
     * 专业标签
     */
    private String proLabelName;

    /**
     * 深度标签
     */
    private String depLabelName;

    /**
     * 目的标签
     */
    private String purLabelName;

    private String serveDesc;

    /**
     * 应用作品下资源数量，客户端可见资源数量
     */
    private Long resourceNum;

    private BigDecimal dealPrice;

    private BigDecimal price;

    private BigDecimal packagePrice;

    /**
     * 制作方
     */
    private String producer;


}
